

#include <windows.h>
#include <fstream.h>
#include <d3d8.h>
#include "zed4d.h"
#include "zhelp.h"
#include "terrain.h"



zTerrain::zTerrain()
{

}



zTerrain::~zTerrain()
{
   Destroy();
}



bool zTerrain::Create(const char* name)
{
   terrvertex   *aterr;
   ifstream file;
   unsigned char c;
   int num=0;
   terrvertex* v;

   aheightmap = (short*) malloc(128*128*sizeof(short));
   aterr = (terrvertex*) malloc(127*127*6*sizeof(terrvertex));
   if (aheightmap == NULL || aterr == NULL)
      return false;

   file.open(name,ios::binary);
   for (int z=0; z < 128; z++) {
      for (int x=0; x < 128; x++) {
         file.get(c);
         aheightmap[ind(x,z)] = (short)c;
      }
   }
   file.close();

   for (z=0; z < 127; z++) {
      for (int x=0; x < 127; x++) {
         aterr[num].x = (float) x;
         aterr[num].z = (float) z;
         aterr[num].y = (float)aheightmap[ind(x,z)] / 25.6f;
         aterr[num].diffuse = aheightmap[ind(x,z)];

         aterr[num+1].x = (float) x+1;
         aterr[num+1].z = (float) z;
         aterr[num+1].y = (float)aheightmap[ind(x+1,z)] / 25.6f;
         aterr[num+1].diffuse = aheightmap[ind(x,z)];

         aterr[num+2].x = (float) x+1;
         aterr[num+2].z = (float) z+1;
         aterr[num+2].y = (float)aheightmap[ind(x+1,z+1)] / 25.6f;
         aterr[num+2].diffuse = aheightmap[ind(x,z)];

         aterr[num+3].x = (float) x;
         aterr[num+3].z = (float) z;
         aterr[num+3].y = (float)aheightmap[ind(x,z)] / 25.6f;
         aterr[num+3].diffuse = aheightmap[ind(x,z)];

         aterr[num+4].x = (float) x+1;
         aterr[num+4].z = (float) z+1;
         aterr[num+4].y = (float)aheightmap[ind(x+1,z+1)] / 25.6f;
         aterr[num+4].diffuse = aheightmap[ind(x,z)];

         aterr[num+5].x = (float) x;
         aterr[num+5].z = (float) z+1;
         aterr[num+5].y = (float)aheightmap[ind(x,z+1)] / 25.6f;
         aterr[num+5].diffuse = aheightmap[ind(x,z)];
      
         num += 6;
      }
   }

   _httest( pDev->CreateVertexBuffer(127*127*6*sizeof(terrvertex),D3DUSAGE_WRITEONLY,D3DFVF_TERRAIN,D3DPOOL_MANAGED,&pVB),
           "CreateVertexBuffer failed\n");

   _httest( pVB->Lock(0,0,(BYTE**)&v,D3DLOCK_DISCARD) ,
           "Lock failed\n");

   for (int i=0; i<127*127*6; i++)
      v[i] = aterr[i];
   
   _httest( pVB->Unlock() ,
           "Unlock failed");

   free(aterr);

   return true;
}



void zTerrain::Destroy()
{
   _release(pVB);
   free(aheightmap);
}



bool zTerrain::Draw(zVector3 pos)
{
   _httest( _setvs(D3DFVF_TERRAIN) ,
           "SetVertexShader failed\n");
   _httest( _setss(0,pVB,terrvertex) ,
           "SetStreamSource failed\n");
   _httest( _drawp(D3DPT_TRIANGLELIST,0,127*127*2) ,
           "Draw Terrain failed\n");
}